image: ruby:2.3

rspec:
  services:
    - postgres:latest

  variables:
    # Configure PostGreSQL environment variables (https://hub.docker.com/_/postgres/)
    POSTGRES_USER: sih_api
    POSTGRES_PASSWORD: sih_api
    POSTGRES_DB: sih_api_test

  script:
    - cp config/database-ci.yml config/database.yml
    - gem install bundler --no-ri --no-rdoc
    - bundle check || bundle install
    - RAILS_ENV=test bundle exec rake db:create
    - RAILS_ENV=test bundle exec rake db:migrate
    - bundle exec rspec
  artifacts:
    paths:
      - coverage/

coverage:
  stage: deploy
  dependencies:
    - rspec
  script:
    - mv coverage/ public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - master

code_quality:
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths: [gl-code-quality-report.json]